"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HighlightRenderer = exports.HighlighterElementTag = exports.HighlighterViewTag = void 0;
var node_1 = require("../utils/node");
exports.HighlighterViewTag = 'KONTENT-SMART-LINK-OVERLAY';
exports.HighlighterElementTag = 'KONTENT-SMART-LINK-ELEMENT';
var HighlightRenderer = /** @class */ (function () {
    function HighlightRenderer() {
        var _this = this;
        this.destroy = function () {
            var _a, _b;
            _this.clear();
            (_b = (_a = _this.view) === null || _a === void 0 ? void 0 : _a.parentElement) === null || _b === void 0 ? void 0 : _b.removeChild(_this.view);
        };
        this.selectNode = function (node) {
            var highlight = _this.highlightByNode.get(node);
            if (highlight) {
                node.style.cursor = 'pointer';
                highlight.classList.add('selected');
            }
        };
        this.deselectNode = function (node) {
            var highlight = _this.highlightByNode.get(node);
            if (highlight) {
                node.style.removeProperty('cursor');
                highlight.classList.remove('selected');
            }
        };
        this.render = function (nodes) {
            var e_1, _a, e_2, _b;
            var _c;
            if (nodes.size === 0) {
                _this.clear();
            }
            else {
                var newHighlightByNode = new Map();
                try {
                    for (var nodes_1 = __values(nodes), nodes_1_1 = nodes_1.next(); !nodes_1_1.done; nodes_1_1 = nodes_1.next()) {
                        var node = nodes_1_1.value;
                        var rect = node.getBoundingClientRect();
                        var overlapped = node_1.isNodeOverlapped(node, rect);
                        var flat = rect.height === 0 || rect.width === 0;
                        if (!overlapped && !flat) {
                            var highlight = (_c = _this.highlightByNode.get(node)) !== null && _c !== void 0 ? _c : _this.createHighlightForNode();
                            highlight.style.top = rect.top + window.pageYOffset + "px";
                            highlight.style.left = rect.left + window.pageXOffset + "px";
                            highlight.style.width = rect.width + "px";
                            highlight.style.height = rect.height + "px";
                            newHighlightByNode.set(node, highlight);
                            _this.highlightByNode.delete(node);
                        }
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (nodes_1_1 && !nodes_1_1.done && (_a = nodes_1.return)) _a.call(nodes_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                try {
                    for (var _d = __values(_this.highlightByNode.entries()), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var _f = __read(_e.value, 2), node = _f[0], highlight = _f[1];
                        highlight.remove();
                        _this.highlightByNode.delete(node);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                _this.highlightByNode = newHighlightByNode;
            }
        };
        this.clear = function () {
            _this.view.innerHTML = '';
            _this.highlightByNode = new Map();
        };
        this.createHighlightForNode = function () {
            var highlight = document.createElement(exports.HighlighterElementTag);
            _this.view.appendChild(highlight);
            return highlight;
        };
        this.highlightByNode = new Map();
        this.view = HighlightRenderer.createView();
    }
    HighlightRenderer.createView = function () {
        var view = document.createElement(exports.HighlighterViewTag);
        window.document.body.appendChild(view);
        return view;
    };
    return HighlightRenderer;
}());
exports.HighlightRenderer = HighlightRenderer;
//# sourceMappingURL=HighlightRenderer.js.map