import { IElementClickMessageData } from './IFrameCommunicator';
export declare const NodeVisibilityThreshold = 0.5;
export declare enum NodeSmartLinkProviderEventType {
    ElementClicked = "kontent:element:click"
}
export declare type NodeSmartLinkProviderMessagesMap = {
    readonly [NodeSmartLinkProviderEventType.ElementClicked]: (data: Partial<IElementClickMessageData>) => void;
};
export declare class NodeSmartLinkProvider {
    enabled: boolean;
    private readonly events;
    private readonly mutationObserver;
    private readonly intersectionObserver;
    private readonly renderer;
    private renderingTimeoutId;
    private observedElements;
    private visibleElements;
    constructor();
    destroy: () => void;
    addEventListener: <E extends NodeSmartLinkProviderEventType.ElementClicked>(type: E, listener: NodeSmartLinkProviderMessagesMap[E]) => void;
    removeEventListener: <E extends NodeSmartLinkProviderEventType.ElementClicked>(type: E, listener: NodeSmartLinkProviderMessagesMap[E]) => void;
    enable: () => void;
    disable: () => void;
    private highlightVisibleElements;
    /**
     * Start an interval rendering (1s) using `setTimeout`. This helps to adjust highlights position in case of CSS
     * animations, DOM attribute animations, etc. for better user experience since the NodeSmartLinkProvider currently
     * can't detect those changes of element position.
     */
    private startRenderingInterval;
    private stopRenderingInterval;
    private listenToGlobalEvents;
    private unlistenToGlobalEvents;
    private observeDomMutations;
    private disconnectObservers;
    private observeElementVisibility;
    private unobserveElementVisibility;
    private onDomMutation;
    private onElementVisibilityChange;
    private onElementClick;
    private onElementMouseEnter;
    private onElementMouseLeave;
}
