export interface IPluginConfiguration {
    readonly languageCodename: string | null;
    readonly projectId: string | null;
    readonly queryParam: string;
}
declare class Plugin {
    private state;
    private configuration;
    private iFrameCommunicator?;
    private readonly nodeSmartLinkProvider;
    constructor(configuration?: Partial<IPluginConfiguration>);
    destroy: () => void;
    updateConfiguration: (configuration: Partial<IPluginConfiguration>) => void;
    private updateState;
    private initializeIFrameCommunication;
    private watchQueryParams;
    private unwatchQueryParams;
    private listenToHighlighterEvents;
    private onElementClick;
    private toggleNodeSmartLinkProvider;
}
declare class PluginWrapper {
    private static plugin;
    static initializeOnLoad(configuration?: Partial<IPluginConfiguration>): Promise<Plugin>;
    static initialize(configuration?: Partial<IPluginConfiguration>): Plugin;
    destroy(): void;
    setConfiguration(configuration: Partial<IPluginConfiguration>): void;
}
export default PluginWrapper;
